

world
	name = "Alternate Movement demo"
	view = 7

	tick_lag = 0.1
	turf = /turf/grass
	mob = /car



	// When the program starts...
	New()

		// When the world starts up, begin the repeating loop that moves all the cars.
		spawn(world.tick_lag)
			MovePlayers()

		return ..()


mob/Login()
	src.loc = locate(38,51,1)
	src << sound('driver.mod', repeat=1, channel=2, volume=30)
	return


// Global variables:
var
	list/CarsInWorld = list()
	const/tile_radius = 100


// *** Player controls! ***
client
	verb
		Accel()
			var/car/car = mob
			car.accelerating = 1

		RAccel()
			var/car/car = mob
			car.accelerating = 0

		Left()
			var/car/car = mob
			car.turning--

		RLeft()
			var/car/car = mob
			car.turning++

		Right()
			var/car/car = mob
			car.turning++

		RRight()
			var/car/car = mob
			car.turning--

		Brake()
			var/car/car = mob
			car.braking = 1

		RBrake()
			var/car/car = mob
			car.braking = 0


// Global function to have all the cars respond to their client inputs.

proc/MovePlayers()

	while(1)

		// Loop through all the cars in the world and have them respond to their client inputs.
		for(var/car/C in CarsInWorld)

			// If the car is trying to turn and is also moving, then turn it.
			if(C.turning && C.velocity)
				if(C.velocity < 0)
					C.Turn(-C.turning)
				else
					C.Turn(C.turning)

			// This was the car's velocity before changes were made.
			var/starting_velocity = C.velocity

			// If the cars is accelerating and not also braking
			if(C.accelerating && !C.braking)

				// This is the amount added to the car's velocity when it accelerates.
				var/velocity_bonus = C.acceleration

				// If you want acceleration to be reduced as the car speeds up, include this:
				var/percent_max_speed = 100 / C.max_velocity * C.velocity
				velocity_bonus = C.acceleration - (C.acceleration / 100 * percent_max_speed)

				C.velocity = min(C.velocity + velocity_bonus, C.max_velocity)

			// If the car was not accelerating but is braking, then have it brake or
			// go into reverse.
			else if(C.braking && !C.accelerating)
				C.velocity = max(C.velocity - C.brake_speed, C.max_reverse)

			// If the car is not accelerating or braking, but is moving forward, then
			// have it slow down gradually.
			else if(C.velocity > 0)
				C.velocity = max(C.velocity - C.deceleration, 0)

			// If it has not accelerating or braking but is moving backwards, then have
			// is slow down gradually the other way.
			else if(C.velocity < 0)
				C.velocity = min(C.velocity + C.deceleration, 0)

			if(C.velocity != starting_velocity)
				C.UpdateMotoSound()

			// Now move the car.
			if(C.velocity)
				C.Drive()

			// Now wait and moment and repeat...
			sleep(world.tick_lag)







































